# Smart Card Reader Script

## Intended Audience

The **Smart Card Reader (SCR) script** is designed for users running Ubuntu 22.04 who have not configured their machine to recognize and use a smart card reader (e.g. a CAC reader).

> macOS or Windows have built-in support for smart card readers and do not need to run this script

## Overview

Running the script does the following:

- Installs:
  - OpenSC
  - Middleware libraries and tools required to read the CAC
  - CACKey
- Enables pcscd

The smart card reader configuration can be checked with the [Verification Process](#verification-process).

## Usage

### Recommended Usage

Ubuntu users who need to install and configure their system to work with a smart card reader should complete the following:

Run the [`enable-smart-card-reader` script](./enable-smart-card-reader).

```sh
/usr/bin/env bash -c "$(curl -fsSL https://gitlab.com/act3-ai/asce/up/-/raw/main/smart-card-reader/enable-smart-card-reader)"
```

### Optional Usage

#### Clone Repo and Run

Clone the [ASCEup](https://gitlab.com/act3-ai/asce/up) repository to your system:

```sh
git clone https://gitlab.com/act3-ai/asce/up.git
```

Then, run the [`enable-smart-card-reader` script](./enable-smart-card-reader):

```sh
./up/smart-card-reader/enable-smart-card-reader
```

### Verification Process

After running the script, connect the card reader and insert the card. Then, check the slot:

```sh
pkcs11-tool -L
```

Example of output showing the slot is active:

```sh
Available slots:
Slot 0 (0x0): Broadcom Corp 5880 [Contacted SmartCard] (0123456789ABCD) 00 00
  token label        : LASTNAME.FIRSTNAME.0123456789
  token manufacturer : piv_II
  token model        : PKCS#15 emulated
  token flags        : login required, token initialized, PIN initialized
  hardware version   : 0.0
  firmware version   : 0.0
  serial num         : 380aa1857810d7f3
  pin min/max        : 4/8
```

## Support

- **[Troubleshooting FAQ](faq.md)**: consult list of frequently asked questions and their answers.
- **[Create a support ticket](https://gitlab.com/act3-ai/asce/up/issues/new)**: create a support ticket issue on the ASCEup GitLab project.
- **[Mattermost channel](https://chat.git.act3-ace.com/act3/channels/devops)**: create a post in the DevOps channel for assistance.
